/* samples/dhry_1.c, os_open_walnut_samplesE, osop_4m_walnut 3/11/99 19:01:55
 ****************************************************************************
 *
 *                   "DHRYSTONE" Benchmark Program
 *                   -----------------------------
 *
 *  Version:    C, Version 2.1
 *
 *  File:       dhry_1.c (part 2 of 3)
 *
 *  Date:       May 25, 1988
 *
 *  Author:     Reinhold P. Weicker
 *
 *  Modified for PPC TMR Application Note by Greg Miller at Xilinx
 *  This was to reduce the memory footprint. 5-7-07
 *  Most Comments were kept for reference
 ****************************************************************************
 */

#include "dhry.h"
#include "xtime_l.h"
#include "xparameters.h"
//#include "xuartns550_l.h"
#include "xutil.h"
#include "xcache_l.h"
#include "xgpio_l.h"


#define printf xil_printf

/* Global Variables: */

Rec_Pointer     Ptr_Glob,
                Next_Ptr_Glob;
int             Int_Glob;
Boolean         Bool_Glob;
char            Ch_1_Glob,
                Ch_2_Glob;
int             Arr_1_Glob [50];
int             Arr_2_Glob [50] [50];

extern char     *malloc ();
Enumeration     Func_1 ();
  /* forward declaration necessary since Enumeration may not simply be int */

#ifndef REG
        Boolean Reg = false;
#define REG
        /* REG becomes defined as empty */
        /* i.e. no register variables   */
#else
        Boolean Reg = true;
#endif

/* variables for time measurement: */

//#ifdef TIMES
//struct tms      time_info;
//clock_t _EXFUN(times,(struct tms *));
                /* see library function "times" */
//#define Too_Small_Time 120
                /* Measurements should last at least about 2 seconds */
//#endif
//#ifdef TIME
//extern long     time();
                /* see library function "time"  */
#define Too_Small_Time 2
                /* Measurements should last at least 2 seconds */
//#endif

XTime           Initial_time;
XTime           current_time;

//unsigned long long  Begin_Time, End_Time;
unsigned long  Begin_Time, End_Time;
//                User_Time;
//float           User_Time;
unsigned long     User_Time;


//float           Microseconds, Dhrystones_Per_Second;
unsigned long     Microseconds, Dhrystones_Per_Second;

//Just for a counter
unsigned i;

/* end of variables for time measurement */

void WriteToGPOutput(Xuint32 BaseAddress, int gpio_width) {   int i=0, j=0;   volatile int delay=0;   int numTimes = 5;
   XGpio_mSetDataDirection(BaseAddress, 1, 0x00000000);   /* Set as outputs */
   while (numTimes > 0) {
      j = 1;
      for(i=0; i<(gpio_width-1); i++) {
         XGpio_mSetDataReg(BaseAddress, 1, j);
         for (delay=0; delay<1000000; delay++) {
            ; 
         }
      }
        j = 0;
      for(i=0; i<(gpio_width-1); i++) {
         XGpio_mSetDataReg(BaseAddress, 1, j);
         for (delay=0; delay<1000000; delay++) {
            ;
         }
      }
      numTimes--;
   }
}
void StartIndication(void) {
     XGpio_mSetDataDirection(XPAR_LEDS_2BIT_BASEADDR, 1, 0x00000000);   /* Set as outputs */
     XGpio_mSetDataReg(XPAR_LEDS_2BIT_BASEADDR, 1, 1);
}
void FinishIndication(void) {
     XGpio_mSetDataDirection(XPAR_LEDS_2BIT_BASEADDR, 1, 0x00000000);   /* Set as outputs */
     XGpio_mSetDataReg(XPAR_LEDS_2BIT_BASEADDR, 1, 2);
}

void ClearIndication(void) {     XGpio_mSetDataDirection(XPAR_LEDS_2BIT_BASEADDR, 1, 0x00000000);   /* Set as outputs */
     XGpio_mSetDataReg(XPAR_LEDS_2BIT_BASEADDR, 1, 0);}




main ()
/*****/

  /* main program, corresponds to procedures        */
  /* Main and Proc_0 in the Ada version             */
{
        One_Fifty       Int_1_Loc;
  REG   One_Fifty       Int_2_Loc;
        One_Fifty       Int_3_Loc;
  REG   char            Ch_Index;
        Enumeration     Enum_Loc;
        Str_30          Str_1_Loc;
        Str_30          Str_2_Loc;
  REG   int             Run_Index;
//  REG   int             Number_Of_Runs;
long                    Number_Of_Runs;

  int n;

//UnComment to enable cache
//   XCache_EnableICache(0x00000001);
//   XCache_EnableDCache(0x00000001);

   /* Initialize RS232 - Set baudrate and number of stop bits */
   //XUartNs550_SetBaud(XPAR_RS232_BASEADDR, XPAR_XUARTNS550_CLOCK_HZ, 115200);
   //XUartNs550_mSetLineControlReg(XPAR_RS232_BASEADDR, XUN_LCR_8_DATA_BITS);

while(1)
{

  /* Initializations */
  
  

  Next_Ptr_Glob = (Rec_Pointer) malloc (sizeof (Rec_Type));
  Ptr_Glob = (Rec_Pointer) malloc (sizeof (Rec_Type));

  Ptr_Glob->Ptr_Comp                    = Next_Ptr_Glob;
  Ptr_Glob->Discr                       = Ident_1;
  Ptr_Glob->variant.var_1.Enum_Comp     = Ident_3;
  Ptr_Glob->variant.var_1.Int_Comp      = 40;
  strcpy (Ptr_Glob->variant.var_1.Str_Comp,
          "DHRYSTONE PROGRAM, SOME STRING");
  strcpy (Str_1_Loc, "DHRYSTONE PROGRAM, 1'ST STRING");

  Arr_2_Glob [8][7] = 10;
        /* Was missing in published program. Without this statement,    */
        /* Arr_2_Glob [8][7] would have an undefined value.             */
        /* Warning: With 16-Bit processors and Number_Of_Runs > 32000,  */
        /* overflow may occur for this array element.                   */

  printf ("\r\r\n");
  printf ("Dhrystone Benchmark, Version 2.1 (Language: C)\r\r\n");
  printf ("\r\n");
  if (Reg)
  {
    printf ("Program compiled with 'register' attribute\r\n");
    printf ("\r\n");
  }
  else
  {
    printf ("Program compiled without 'register' attribute\r\n");
    printf ("\r\n");
  }
//  print ("Please give the number of runs through the benchmark: ");
//  {
//    int n;
//    scanf ("%d", &n);    /* DJP: get rid of scanf() because >10KB */
//   Number_Of_Runs = n;
   //Number_Of_Runs = 1000000;
   Number_Of_Runs = 100000;
    /* XAPP507:  for 1% DMIPS error precision, @ 300MHz, must
	 * run 333,333,333 iterations. So just set it for 350,000,000
	 * iterations, therefore, any frequency under 300MHz will 
	 * result in a very precise DMIPs measurement.
	 * It will just take a LONG time to run:
	 * 100MHz: 20 minutes
	 * 200MHz: 10 minutes
	 * 300MHz: 7 minutes
	 *
	 * I get the same results w/ it set at 1,000,000, so I'm just going
	 * to leave it there
	 *
	 */

//  }
  printf ("\r\n");

  printf ("Execution starts, %d runs through Dhrystone\r\n", Number_Of_Runs);
  
  StartIndication();  //Indicate Dhrystone Start (With LEDs)

  /***************/
  /* Start timer */
  /***************/

//#ifdef TIMES
//  times(&time_info);
//  Begin_Time = (long) time_info.tms_utime;
//#endif
//#ifdef TIME
//  Begin_Time = time ( (long *) 0);
//#endif

  Initial_time = 0;
  XTime_SetTime(Initial_time);

  XTime_GetTime(&current_time);
  Begin_Time = current_time;


  for (Run_Index = 1; Run_Index <= Number_Of_Runs; ++Run_Index)
  {

    Proc_5();
    Proc_4();
      /* Ch_1_Glob == 'A', Ch_2_Glob == 'B', Bool_Glob == true */
    Int_1_Loc = 2;
    Int_2_Loc = 3;
    strcpy (Str_2_Loc, "DHRYSTONE PROGRAM, 2'ND STRING");
    Enum_Loc = Ident_2;
    Bool_Glob = ! Func_2 (Str_1_Loc, Str_2_Loc);
      /* Bool_Glob == 1 */
    while (Int_1_Loc < Int_2_Loc)  /* loop body executed once */
    {
      Int_3_Loc = 5 * Int_1_Loc - Int_2_Loc;
        /* Int_3_Loc == 7 */
      Proc_7 (Int_1_Loc, Int_2_Loc, &Int_3_Loc);
        /* Int_3_Loc == 7 */
      Int_1_Loc += 1;
    } /* while */
      /* Int_1_Loc == 3, Int_2_Loc == 3, Int_3_Loc == 7 */
    Proc_8 (Arr_1_Glob, Arr_2_Glob, Int_1_Loc, Int_3_Loc);
      /* Int_Glob == 5 */
    Proc_1 (Ptr_Glob);
    for (Ch_Index = 'A'; Ch_Index <= Ch_2_Glob; ++Ch_Index)
                             /* loop body executed twice */
    {
      if (Enum_Loc == Func_1 (Ch_Index, 'C'))
          /* then, not executed */
        {
        Proc_6 (Ident_1, &Enum_Loc);
        strcpy (Str_2_Loc, "DHRYSTONE PROGRAM, 3'RD STRING");
        Int_2_Loc = Run_Index;
        Int_Glob = Run_Index;
        }
    }
      /* Int_1_Loc == 3, Int_2_Loc == 3, Int_3_Loc == 7 */
    Int_2_Loc = Int_2_Loc * Int_1_Loc;
    Int_1_Loc = Int_2_Loc / Int_3_Loc;
    Int_2_Loc = 7 * (Int_2_Loc - Int_3_Loc) - Int_1_Loc;
      /* Int_1_Loc == 1, Int_2_Loc == 13, Int_3_Loc == 7 */
    Proc_2 (&Int_1_Loc);
      /* Int_1_Loc == 5 */

  } /* loop "for Run_Index" */

  /**************/
  /* Stop timer */
  /**************/

//#ifdef TIMES
//  times (&time_info);
//  End_Time = (long) time_info.tms_utime;
//#endif
//#ifdef TIME
//  End_Time = time ( (long *) 0);
//#endif

  XTime_GetTime(&current_time);
  End_Time = current_time;
  
  FinishIndication(); //End LED indication
  for (i=0; i<1000000; i++){};

//  printf ("Execution ends\r\n");
//  printf ("\r\n");
//  printf ("Final values of the variables used in the benchmark:\r\n");
//  printf ("\r\n");
//  printf ("Int_Glob:            %d\r\n", Int_Glob);
//  printf ("        should be:   %d\r\n", 5);
//  printf ("Bool_Glob:           %d\r\n", Bool_Glob);
//  printf ("        should be:   %d\r\n", 1);
//  printf ("Ch_1_Glob:           %c\r\n", Ch_1_Glob);
//  printf ("        should be:   %c\r\n", 'A');
//  printf ("Ch_2_Glob:           %c\r\n", Ch_2_Glob);
//  printf ("        should be:   %c\r\n", 'B');
//  printf ("Arr_1_Glob[8]:       %d\r\n", Arr_1_Glob[8]);
//  printf ("        should be:   %d\r\n", 7);
//  printf ("Arr_2_Glob[8][7]:    %d\r\n", Arr_2_Glob[8][7]);
//  printf ("        should be:   Number_Of_Runs + 10\r\n");
//  printf ("Ptr_Glob->\r\n");
//  printf ("  Ptr_Comp:          %d\r\n", (int) Ptr_Glob->Ptr_Comp);
//  printf ("        should be:   (implementation-dependent)\r\n");
//  printf ("  Discr:             %d\r\n", Ptr_Glob->Discr);
//  printf ("        should be:   %d\r\n", 0);
//  printf ("  Enum_Comp:         %d\r\n", Ptr_Glob->variant.var_1.Enum_Comp);
//  printf ("        should be:   %d\r\n", 2);
//  printf ("  Int_Comp:          %d\r\n", Ptr_Glob->variant.var_1.Int_Comp);
//  printf ("        should be:   %d\r\n", 17);
//  printf ("  Str_Comp:          %s\r\n", Ptr_Glob->variant.var_1.Str_Comp);
//  printf ("        should be:   DHRYSTONE PROGRAM, SOME STRING\r\n");
//  printf ("Next_Ptr_Glob->\r\n");
//  printf ("  Ptr_Comp:          %d\r\n", (int) Next_Ptr_Glob->Ptr_Comp);
//  printf ("        should be:   (implementation-dependent), same as above\r\n");
//  printf ("  Discr:             %d\r\n", Next_Ptr_Glob->Discr);
//  printf ("        should be:   %d\r\n", 0);
//  printf ("  Enum_Comp:         %d\r\n", Next_Ptr_Glob->variant.var_1.Enum_Comp);
//  printf ("        should be:   %d\r\n", 1);
//  printf ("  Int_Comp:          %d\r\n", Next_Ptr_Glob->variant.var_1.Int_Comp);
//  printf ("        should be:   %d\r\n", 18);
//  printf ("  Str_Comp:          %s\r\n",
//                                Next_Ptr_Glob->variant.var_1.Str_Comp);
//  printf ("        should be:   DHRYSTONE PROGRAM, SOME STRING\r\n");
//  printf ("Int_1_Loc:           %d\r\n", Int_1_Loc);
//  printf ("        should be:   %d\r\n", 5);
//  printf ("Int_2_Loc:           %d\r\n", Int_2_Loc);
//  printf ("        should be:   %d\r\n", 13);
//  printf ("Int_3_Loc:           %d\r\n", Int_3_Loc);
//  printf ("        should be:   %d\r\n", 7);
//  printf ("Enum_Loc:            %d\r\n", Enum_Loc);
//  printf ("        should be:   %d\r\n", 1);
//  printf ("Str_1_Loc:           %s\r\n", Str_1_Loc);
//  printf ("        should be:   DHRYSTONE PROGRAM, 1'ST STRING\r\n");
//  printf ("Str_2_Loc:           %s\r\n", Str_2_Loc);
//  printf ("        should be:   DHRYSTONE PROGRAM, 2'ND STRING\r\n");
//  printf ("\r\n");

//User_Time = (float)(End_Time - Begin_Time) / (float)XPAR_CPU_PPC405_CORE_CLOCK_FREQ_HZ;
  User_Time = (End_Time - Begin_Time) / XPAR_CPU_PPC405_CORE_CLOCK_FREQ_HZ;
  printf ("\r\nTotalruns: %d\r\n", Number_Of_Runs);
  printf ("\r\nBeginPoint: %d\r\n", Begin_Time);
  printf ("\r\nEndPoint: %d\r\n", End_Time);
  printf ("\r\nUserTime: %d seconds\r\n", User_Time);
//  printf ("\r\nMic_secs_Per_Second: %f\r\n", Mic_secs_Per_Second);
//  printf ("\r\nBeginTime: %llu\r\n", Begin_Time);
//  printf ("\r\nEndTime: %llu\r\n", End_Time);
//  printf ("\r\nUserTime: %f\r\n", User_Time);
  

//  if (User_Time < Too_Small_Time)
//  {
//    print ("\r\nMeasured time too small to obtain meaningful results\r\n");
//    print ("Please increase number of runs\r\n");
//    print ("\r\n");
//  }
//  else
//  {
//#ifdef TIME
//    Microseconds = User_Time * (float)Mic_secs_Per_Second / (float) Number_Of_Runs;
//    Dhrystones_Per_Second = (float) Number_Of_Runs / User_Time;
    
    Microseconds = User_Time * Mic_secs_Per_Second / Number_Of_Runs;
    Dhrystones_Per_Second = Number_Of_Runs / User_Time;
//#else
//    Microseconds = (float) User_Time * Mic_secs_Per_Second
//                        / ((float) HZ * ((float) Number_Of_Runs));
//    Dhrystones_Per_Second = ((float) HZ * (float) Number_Of_Runs)
//                        / (float) User_Time;
//#endif
//    printf ("\r\nMicroseconds for one run through Dhrystone: ");
//    printf ("%6.1f \r\n", Microseconds);
//    printf ("Dhrystones per Second:                      ");
//    printf ("%6.1f \r\n", Dhrystones_Per_Second);
//    printf ("\r\n");
    printf ("\r\nMicroseconds for one run through Dhrystone: ");
    printf ("%d \r\n", Microseconds);
    printf ("Dhrystones per Second:                      ");
    printf ("%d \r\n", Dhrystones_Per_Second);
    printf ("\r\n");
//  }
};

   XCache_DisableDCache();
   XCache_DisableICache();


}


Proc_1 (Ptr_Val_Par)
/******************/

REG Rec_Pointer Ptr_Val_Par;
    /* executed once */
{
  REG Rec_Pointer Next_Record = Ptr_Val_Par->Ptr_Comp;
                                        /* == Ptr_Glob_Next */
  /* Local variable, initialized with Ptr_Val_Par->Ptr_Comp,    */
  /* corresponds to "rename" in Ada, "with" in Pascal           */

  structassign (*Ptr_Val_Par->Ptr_Comp, *Ptr_Glob);
  Ptr_Val_Par->variant.var_1.Int_Comp = 5;
  Next_Record->variant.var_1.Int_Comp
        = Ptr_Val_Par->variant.var_1.Int_Comp;
  Next_Record->Ptr_Comp = Ptr_Val_Par->Ptr_Comp;
  Proc_3 (&Next_Record->Ptr_Comp);
    /* Ptr_Val_Par->Ptr_Comp->Ptr_Comp
                        == Ptr_Glob->Ptr_Comp */
  if (Next_Record->Discr == Ident_1)
    /* then, executed */
  {
    Next_Record->variant.var_1.Int_Comp = 6;
    Proc_6 (Ptr_Val_Par->variant.var_1.Enum_Comp,
           &Next_Record->variant.var_1.Enum_Comp);
    Next_Record->Ptr_Comp = Ptr_Glob->Ptr_Comp;
    Proc_7 (Next_Record->variant.var_1.Int_Comp, 10,
           &Next_Record->variant.var_1.Int_Comp);
  }
  else /* not executed */
    structassign (*Ptr_Val_Par, *Ptr_Val_Par->Ptr_Comp);
} /* Proc_1 */


Proc_2 (Int_Par_Ref)
/******************/
    /* executed once */
    /* *Int_Par_Ref == 1, becomes 4 */

One_Fifty   *Int_Par_Ref;
{
  One_Fifty  Int_Loc;
  Enumeration   Enum_Loc;

  Int_Loc = *Int_Par_Ref + 10;
  do /* executed once */
    if (Ch_1_Glob == 'A')
      /* then, executed */
    {
      Int_Loc -= 1;
      *Int_Par_Ref = Int_Loc - Int_Glob;
      Enum_Loc = Ident_1;
    } /* if */
  while (Enum_Loc != Ident_1); /* true */
} /* Proc_2 */


Proc_3 (Ptr_Ref_Par)
/******************/
    /* executed once */
    /* Ptr_Ref_Par becomes Ptr_Glob */

Rec_Pointer *Ptr_Ref_Par;

{
  if (Ptr_Glob != Null)
    /* then, executed */
    *Ptr_Ref_Par = Ptr_Glob->Ptr_Comp;
  Proc_7 (10, Int_Glob, &Ptr_Glob->variant.var_1.Int_Comp);
} /* Proc_3 */


Proc_4 () /* without parameters */
/*******/
    /* executed once */
{
  Boolean Bool_Loc;

  Bool_Loc = Ch_1_Glob == 'A';
  Bool_Glob = Bool_Loc | Bool_Glob;
  Ch_2_Glob = 'B';
} /* Proc_4 */


Proc_5 () /* without parameters */
/*******/
    /* executed once */
{
  Ch_1_Glob = 'A';
  Bool_Glob = false;
} /* Proc_5 */


        /* Procedure for the assignment of structures,          */
        /* if the C compiler doesn't support this feature       */
#ifdef  NOSTRUCTASSIGN
memcpy (d, s, l)
register char   *d;
register char   *s;
register int    l;
{
        while (l--) *d++ = *s++;
}
#endif


